#ifndef AGL_H
#define AGL_H

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

extern int agldimen, aglsize;

typedef unsigned long long ullong;

typedef  uint16_t  shortvec;
typedef shortvec * agl;

typedef struct _group_{
  agl per;
  struct _group_* next;
} enraglGroup, *aglGroup;

void initagldim( int d );//+
shortvec  aglImage( shortvec x, agl s );//+
void pagl( FILE*dst, agl s);//+
void paglmsg( FILE*dst, char* msg, agl s);//+

aglGroup  mkaglGroup(  );//+
aglGroup  mkglGroup( );
void  aglfreeGroup( aglGroup );

ullong glcard( int  m );
ullong aglcard( int  m );

int  agldet( agl a);
int isaglidentity( agl x );
agl aglComposebyinverse( agl s, agl t);
agl getaglCompose( agl s, agl t);
agl aglConjugate( agl A, agl s);
agl aglComposeInverse( agl A, agl g );
aglGroup aglGroupConjugue( agl left, aglGroup ldg, agl right);

agl opS( void );
agl opT( void );
agl opU( void );

void pshortvec( FILE *dst, shortvec v );
agl getaglrand(  shortvec u );

void agladd( agl res, agl s);
int  isaglidt(  agl res );
void msgagl( FILE*dst, char *msg, agl s);

void setaglidt(  agl r, shortvec u );
agl getagl(  shortvec u );
agl getaglcpy( agl A );
agl getaglidt(  shortvec u );
void freeagl(  agl r );


agl agltranspose(agl s);
aglGroup aglnewgrp( void );
agl aglinverse( agl s );
aglGroup aglGroupcpy( aglGroup ldg);
int aglcmp( agl A, agl B );

void  addgen( agl p, aglGroup *G );
void  addgencpy( agl p, aglGroup *G );
agl aglrand( int flag );
void paglGroup( FILE*dst, aglGroup);
void addgenstr( char bfr[], aglGroup *g);
int aglorder( agl s );
agl aglpower( agl s, int n );
agl strtoagl( char bfr[] );



#endif
