#include <stdio.h>
#include "equiv.h"
int verbose = 0;
int64_t  maxtrials = 32;


vector CODE[9];
vector PIVOT[9];

int rank;

int SmallBitImage(int* mat, int x, int m)
{
  int i, y = 0;
for( i = 0; i < m; i++)
  {
  if (1==(x % 2)) y = y ^mat[i];
  x =x >> 1;
  }
return(y);  
}

int* SmallBitMatCopie(int* mat, int li)
{
int i;
int *res;
 res = ( int*) malloc( li * sizeof(int) );
for( i=0; i<li; i++) res[i]   = mat[i];
return( res );
}
int* InvSmallMat(int* mat , int li )
{
	int i,j, bit, tmp;
        int * r, *b;
        b = SmallBitMatCopie( mat , li );
        r = ( int* ) calloc( li, sizeof(int) );
        for( i = 0; i < li; i++)
	  r[i] = 1 << i;
        bit = 1;
        for( i = 0; i < li; i++, bit <<= 1 ) {
	     j = i;
             while ( 0 == ( b[j] & bit) ) j++;
             tmp = b[i]; b[i] = b[j]; b[j] = tmp;
             tmp = r[i]; r[i] = r[j]; r[j] = tmp;
	     for( j = i + 1;  j < li; j++)
                  if (  b[j] &  bit ) 
		    { b[j] ^= b[i]; r[j]^=r[i];}
             }
        bit =  1 << ( li - 1);
        for( i = li-1; i >=0  ; i--, bit >>= 1 ) {
	     for( j = i - 1;  j >=0 ; j--)
                  if (  b[j] &  bit ) 
		     { b[j] ^= b[i]; r[j]^=r[i];}
             }
free(b);
return (r);
}

void PrdSmallMat(int *a , int* b, int* r, int m)
// calcul le produit AB dans r
{ 
  int * t, i;
 
  t = ( int*) calloc( m , sizeof(int) );
for(i=0; i < m ; i++) 
     t[i] = SmallBitImage(b, a[i], m);
for(i=0; i < m ; i++) 
  r[i] = t[i];
 free( t );
}

int SmallBitMatRang (int *mat , int li, int co)
{
	int i,j, l, res, limite;
        int bit;
        int *b;
        b = ( int* ) malloc( sizeof(int) * li );
        for( i = 0; i < li; i++)
	   b[i] = mat[i];
        limite = ( li < co) ? li : co; 
        res = 0;
        i = 0;
	while ( i < li )
	     {
	     j=0;
             bit = 1;
	     while( ( j < co ) && ( ( b[i] & bit )  == 0 ) ) 
                  { j++; bit = bit << 1;}
	     if ( j != co )
	       {
               res++;
               if (res == limite) { free(b); return res;}
               for( l = i + 1;  l < li; l++)
                  if (  b[l] &  bit ) b[l] ^= b[i];
               }
	     i++;
             }
         free(b);
        return (res);
}	
void Trier( int* t, int n)
{ int i, j, x;
 for( i = 0; i < n; i++)
   for( j = i + 1; j < n; j++)
     if ( t[i] > t[j] ) {x = t[j]; t[j]=t[i]; t[i] = x;}
}

void CleTrier( int* t, int* v, int n)
{ int i, j, x;
 for( i = 0; i < n; i++)
   for( j = i + 1; j < n; j++)
     if ( t[i] > t[j] ) {x = t[j]; t[j]=t[i]; t[i] = x;
                         x = v[j]; v[j]=v[i]; v[i] = x;
                        }
}

int * BonneBase( int* fct, int* val , int m)
{ int i = 0;
  int k = 1, *bb;
  int x;
  int n;
  n = 1 << m;
  bb = ( int * ) malloc( sizeof(int) * m );
 
  while ( 1 ) { 
    for( x = 0; x < n ; x++)
       if ( fct[ x ] == val[i] ) { 
	      bb[ k - 1] = x;
              if ( SmallBitMatRang( bb, k , m) == k ) k++;
              if ( k >  m ) return bb;
            }
    i++; 
    }
}
void  repartition(int* f, int* nbv, int ** val, int ** mul, int m)
{ int i, j;
  int * aux;
  int  n;

  n = 1 << m;

  aux = ( int * ) malloc( sizeof(int) *  n );
  for( i = 0; i < n; i++) aux[i] = f[i];
  Trier( aux, n);
  *nbv = 0;
  for( i = 0; i < n; )
     { j = i; 
       while ( (j < n) && ( aux[j] == aux[i]) )  j++;
       *nbv += 1;
       i = j;
     }


  *val  = ( int * ) malloc( sizeof(int) * ( *nbv  )  );
  *mul  = ( int * ) malloc( sizeof(int) * ( *nbv  )  );
  *nbv = 0;
  for( i = 0; i < n; )
     { j = i; 
       while ( (j < n) && ( aux[j] == aux[i]) )  j++;
       (*val)[ *nbv ] = aux[i];
       (*mul)[ *nbv ] = j - i ;
       *nbv += 1;
       i = j;
     }
 
  free (aux);
}



int**  LesChoix( int * fct, int* gct, int * bb, int *maxi, int m)
{ int** res;
  int i, x, p;
  int n;
  n = 1 << m;
  res = ( int **) malloc( sizeof(int*) * m );
  for( i = 0; i < m; i++) {
    p   =  0;
    res[i] = (int*) malloc( n * sizeof(int) );
    for( x = 0; x < n; x++)
      if ( fct [ bb[i] ] == gct[ x ] ) res[i][p++] = x;  
    maxi[i] = p; 
    }
  
  return res;
}

void PlusLeChoix(int *maxi, int**res, int m)
{ int i;
  for( i = 0; i < m; i++)  
    free( res[i] );
  free( res );
  free( maxi );
}

int   gltest( int *fct, int*gct, int *f, int *g, int *bb , int m)
{ int res = 0;
  int *mat, *src, *dst, x, y;
  int   i, j;
  int *num, *maxi, **choix;
  int* inv, *aux;
  int n;
  n = 1 << m;

  mat = (int*)  malloc( sizeof(int) * m   ); 
  aux = (int*)  malloc( sizeof(int) * m   ); 
  inv = InvSmallMat( bb, m);
 
  src = (int*)  malloc( sizeof(int) * n);
  dst = (int*)  malloc( sizeof(int) * n);
  maxi  = ( int * ) malloc( sizeof(int) * m );
  num  = ( int * ) malloc( sizeof(int) * m );
  choix = LesChoix( f, g, bb, maxi, m);
  src[0] = 0; dst[0] = 0;
  for( i = 0; i < m; i++)  num[i] = -1;
  i = 0;
  while (  i >= 0 ) {
	if ( i == m) { 
	  PrdSmallMat(inv, mat, aux, m); 
	  for( x = 0; x < n && gct[ SmallBitImage(aux, x, m)] == fct[x] ; x++) ;
	  if ( x == n ) {
	    //PrintSmallMat( aux, m); 
	    res = 1;
	    goto outside;
	  }
	 
         i--; 
        }
      //printf("\ni=%d", i);
      num[i]++; mat[ i ] = choix[i][ num[i] ];
      if ( num[i] < maxi[i] ) {
	mat[ i ] = choix[i][ num[i] ];
	if ( SmallBitMatRang( mat , i+1,  m) == i+1) {
            x = 0; y = 0; j = 0;
	    while ( (j < ( 1 << i)) && ( f[ x ] == g[ y ] ) )
                     		{
                     		y = mat[i] ^ dst[j];
                     		x =  bb[i] ^ src[j];
                     		dst[ j ^ ( 1 << i ) ] = y;
                                src[ j ^ ( 1 << i ) ] = x;
                                j++;
                     		}
             if ( j == ( 1 << i ) )  i++;
        }
      } else { num[i] = -1; i--;};
               
  }
outside :

free(num); free(mat); free(dst); free(src);
free(inv); free(aux);
PlusLeChoix( maxi, choix , m);
return( res );
}



int distribtest( int*F, int*G, int q )
{
// assume values between -q and +q 
int cpt[2*q], x;
for( x = 0; x < 2*q; x++ )
	cpt[x] = 0;
for( x = 0; x < q; x++ )
	cpt[ q + F[x] ]++;
for( x = 0; x < q; x++ )
        cpt[ q + G[x] ]--;
for( x = 0; x < q && 0==cpt[x]; x++ );
return x == q;
}

int normalise(vector *mat , vector *piv, int li )
{
        int i, r, l ;
        vector  bit;
    
        r    = li;
        i    = 0;
        while ( i < r ) {
             if ( mat[i] ) {
		bit = 1;
             	while( ( mat[i] & bit )  == 0 )  bit <<=1;
                for( l = i + 1;  l < r; l++)
                  if (  mat[l] &  bit ) mat[l] ^= mat[i];
		piv[i] = bit;
		i++;
               } else {
		       r--;
		       mat[i] = mat[r];
		       mat[r] = 0;
	       }
	       }
        return r;
}

void makespace( uchar* f)
{
uchar d[256];
shortvec x;

int i;
for( i = 0; i < 8; i++ ){
	for( x = 0; x < 256; x++ )
		d[x] = f[x] ^ f[x ^  (1<<i) ]; 
	CODE[i] = booleVector( d, & base );
        }
rank = normalise( CODE, PIVOT, 8 );
}


int Accept( uchar* f, uchar* g, int *src, int * dst  )
{ int i, j;
  shortvec x;
  uchar s[256];
  agl  T, B, A;
  vector vec;
  

  A = getagl( 0 );
  for( j = 0; j < 256; j++ ){
      x = src[j];
      if ( weight(x) == 1 ) {
              i = 0;
              while ( 0 == ( (1<<i) & x ) ) i++;
              A[i] = dst[j];
      }
  }
  T = aglinverse( A );
  B = agltranspose( T  );
  
  // todo
  for( x = 0; x < 256; x++ )
      s[ x ] = g[ aglImage( x, B ) ] ^ f[ x  ] ;
  
  vec = booleVector( s, & base );
  free( A );
  free( B);
  free( T );
  
  for( i = 0; i < rank; i++ )
	  if ( PIVOT[i] & vec ) vec ^= CODE[i];
  return vec == 0;
}




int   glteststrict( uchar *f, uchar* g, int *F, int *G, int *bb , int m, int64_t * trial)
{ int res = 0;
  int *mat, *src, *dst, x, y;
  int   i, j;
  int *num, *maxi, **choix;
  int *aux;
  int n;
  *trial = 0;

  makespace( f ); 


  n = 1 << m;

  mat = (int*)  malloc( sizeof(int) * m   ); 
  aux = (int*)  malloc( sizeof(int) * m   ); 
  
 
  src = (int*)  malloc( sizeof(int) * n);
  dst = (int*)  malloc( sizeof(int) * n);
  maxi  = ( int * ) malloc( sizeof(int) * m );
  num  = ( int * ) malloc( sizeof(int) * m );
  choix = LesChoix( F, G, bb, maxi, m);
  src[0] = 0; dst[0] = 0;
  for( i = 0; i < m; i++)  num[i] = -1;
  i = 0;
  while (  i >= 0 ) {
	if ( i == m) {
	  *trial = (*trial) + 1;
	  if ( *trial > maxtrials ) {
		res = 2;
		goto outside;
	  }
	  if ( Accept( f, g, src, dst  ) ) {	  
	  	res = 1;
	  	goto outside;
	     }
          i--; 
        }
      num[i]++; mat[ i ] = choix[i][ num[i] ];
      if ( num[i] < maxi[i] ) {
	mat[ i ] = choix[i][ num[i] ];
	if ( SmallBitMatRang( mat , i+1,  m) == i+1) {
            x = 0; y = 0; j = 0;
	    while ( (j < ( 1 << i)) && ( F[ x ] == G[ y ] ) )
                     		{
                     		y = mat[i] ^ dst[j];
                     		x =  bb[i] ^ src[j];
                     		dst[ j ^ ( 1 << i ) ] = y;
                                src[ j ^ ( 1 << i ) ] = x;
                                j++;
                     		}
             if ( j == ( 1 << i ) )  i++;
        }
      } else { num[i] = -1; i--;};
               
  }

outside :

free(num); free(mat); free(dst); free(src);
free(aux);
PlusLeChoix( maxi, choix , m);
return( res );
}



int sgltesting( uchar *f, uchar *g, int *F  , int* G, int m, int64_t * trial)
{ int  nbv, * mul , * val;
  int  *base;
  
  int res;

  // we can assume :
  // if ( ! distribtest( F, G, 1<< m) ) return 0;
 
  //printf("\n[ fixator...]\n");
  repartition( F, &nbv, &val, &mul , m);
  //for( i = 0; i < n; i++)   printf("%d ", F[i] );
  CleTrier(mul, val, nbv);
  
  //printf("\nSoit %d valeurs, par ordre de multiplicite :\n", nbv);
  //for( i = 0; i < nbv; i++)
  //  printf("%d (%d fois),  ", val[i], mul[i]);
  
  base = BonneBase( F, val, m);
  //fflush(stdout);
  //printf("\nUne bonne base :\n");
  //for( i = 0; i < m; i++) 
  //  printf("%4d (%3d)", base[i], F[ base[i] ] );
  
  //printf("\nRang =%d", SmallBitMatRang( base, m, m) );
  //printf("\nFixateur =%ld", stabilisateur( F, base) );
  *trial = 0;
  res = glteststrict( f, g, F, G, base , m, trial);
  free(base);
  free(mul);
  free(val);
  return res;
}




int   sglstabtest( uchar *f, int *F,  int *bb , int m, int64_t * trial)
{ int res = 0;
  int *mat, *src, *dst, x, y;
  int   i, j;
  int *num, *maxi, **choix;
  int *aux;
  int n;
  *trial = 0;

  makespace( f ); 


  n = 1 << m;

  mat = (int*)  malloc( sizeof(int) * m   ); 
  aux = (int*)  malloc( sizeof(int) * m   ); 
  
 
  src = (int*)  malloc( sizeof(int) * n);
  dst = (int*)  malloc( sizeof(int) * n);
  maxi  = ( int * ) malloc( sizeof(int) * m );
  num  = ( int * ) malloc( sizeof(int) * m );
  choix = LesChoix( F, F, bb, maxi, m);
  src[0] = 0; dst[0] = 0;
  for( i = 0; i < m; i++)  num[i] = -1;
  i = 0;
  while (  i >= 0 ) {
	if ( i == m) {
	  *trial = (*trial) + 1;
	  if ( *trial > maxtrials ) {
		goto outside;
	  }
	  if ( Accept( f, f, src, dst  ) ) {	  
	  	res++;
	     }
          i--; 
        }
      num[i]++; mat[ i ] = choix[i][ num[i] ];
      if ( num[i] < maxi[i] ) {
	mat[ i ] = choix[i][ num[i] ];
	if ( SmallBitMatRang( mat , i+1,  m) == i+1) {
            x = 0; y = 0; j = 0;
	    while ( (j < ( 1 << i)) && ( F[ x ] == F[ y ] ) )
                     		{
                     		y = mat[i] ^ dst[j];
                     		x =  bb[i] ^ src[j];
                     		dst[ j ^ ( 1 << i ) ] = y;
                                src[ j ^ ( 1 << i ) ] = x;
                                j++;
                     		}
             if ( j == ( 1 << i ) )  i++;
        }
      } else { num[i] = -1; i--;};
               
  }

outside :

free(num); free(mat); free(dst); free(src);
free(aux);
PlusLeChoix( maxi, choix , m);
return( res );
}



int sglstabilizer( uchar *f, int *F, int m, int64_t * trial)
{ int  nbv, * mul , * val;
  int  *base;
  
  int res;

  // we can assume :
  // if ( ! distribtest( F, G, 1<< m) ) return 0;
 
  //printf("\n[ fixator...]\n");
  repartition( F, &nbv, &val, &mul , m);
  //for( i = 0; i < n; i++)   printf("%d ", F[i] );
  CleTrier(mul, val, nbv);
  
  //printf("\nSoit %d valeurs, par ordre de multiplicite :\n", nbv);
  //for( i = 0; i < nbv; i++)
  //  printf("%d (%d fois),  ", val[i], mul[i]);
  
  base = BonneBase( F, val, m);
  //fflush(stdout);
  //printf("\nUne bonne base :\n");
  //for( i = 0; i < m; i++) 
  //  printf("%4d (%3d)", base[i], F[ base[i] ] );
  
  //printf("\nRang =%d", SmallBitMatRang( base, m, m) );
  //printf("\nFixateur =%ld", stabilisateur( F, base) );
  *trial = 0;
  res = sglstabtest( f, F, base , m, trial);
  free(base);
  free(mul);
  free(val);
  return res;
}



