#ifndef FORM_H
#define FORM_H

#include <stdint.h>
#include <stdio.h>
#include "boolean.h"
#include "agltools.h"
#include "classtools.h"

#define BITFORM( j, w ) (    (   (  ( (form) 1) << j  ) & w   )    )

extern int formDimen;
extern int formDegree;
extern int64_t  formSize;

typedef int64_t form;
typedef form * aglForm;

typedef struct _aglFormGroup_ {
	agl per;
	aglForm act;
	struct _aglFormGroup_ * next;
} enraglFormGroup, * aglFormGroup;



void  initForm( int r, int m);
void  closeForm( void );

form booletoform (boole f);
aglForm action (boole f, agl s);


aglForm getaglForm(  void ); 


aglForm action(boole f, agl s);

void  aglFormGroupFree( aglFormGroup l);
// free the act's and l, keeping per in memory.


boole getbooleFormsum( boole fct, form w );
// sum of the Boolean function fct and the form w.

aglFormGroup aglGroupAction( class K );
// builds the generators for the action of
// the class K on the form space


// to do list !

form aglFormImage( form f, aglForm S);
// the image of f by the action S


#endif
