#ifndef INVARIANT_H
#define INVARIANT_H
#include "agltools.h"
#include "boolean.h"
#include "sstools.h"
#include  <ctype.h>
#include "spacetools.h"
#include "agltools.h"
#include "orbit.h"
#include <search.h>


typedef struct _invclass_ {
	int  val;
	int  der;
	int  res ;
} inv_t;
int newInvariant( int d, int r, void **rootp, int* count   );
inv_t*  getInvariant( int d, int r );
int  invRestriction( boole f , int q, basis_t *b, void **root, int * count );
int  invSimpleDerivation( boole f , int q, basis_t *b,  void **r1, int *c1);
int  invDoubleDerivation( boole f , int q, basis_t *b,  void **r1, int *c1, void **r2, int * c2 );
int  invDoubleDerivationKernel( boole f , int q, basis_t *b,  void **r1, int *c1, void **r2, int * c2, basis_t *bq, void **r3, int * c3);
int invDerRes( boole f , int q, basis_t *bd, basis_t *br, void **r1, int *c1);
int invDoubleDerRes( boole f , int q, basis_t *bd, basis_t *br,  void **r1, int *c1, void **r2, int * c2 );
int InvariantValue( int d, int r, void **rootp, int* count   );

int  invKernel( boole f, int r, int s, int t, basis_t * bq  );

#endif
