#ifndef SPACE_H
#define SPACE_H

#include <stdint.h>
#include <stdio.h>
#include "boolean.h"
#include "agltools.h"
#include "classtools.h"

#define BITSPACE( j, w ) (    (   (  ( (space) 1) << j  ) & w   )    )

extern int spaceDimen;
extern int spaceDegree;
extern size_t  spaceSize;

typedef int64_t space;
typedef space * aglSpace;

typedef struct _aglSpaceGroup_ {
	agl per;
	aglSpace act;
	struct _aglSpaceGroup_ * next;
} enraglSpaceGroup, * aglSpaceGroup;



void  initSpace( int s, int t, int m);
void  closeSpace( void );

int64_t smallboole(boole f );
int64_t prepareDirac( void  );
space booletospace (boole f);
boole spacetoboole( space w );
aglSpace spaceAction ( agl s);


aglSpace getaglSpace(  void ); 


void  aglSpaceGroupFree( aglSpaceGroup l);
// free the act's and l, keeping per in memory.


aglSpaceGroup aglSpaceGroupAction( aglGroup S );
// builds the generators for the action of
// the class K on the space space


// to do list !

space aglSpaceImage( space f, aglSpace S);
// the image of f by the action S

int orbitSpace( aglGroup g, boole f, class *r  );

#endif
