#ifndef AGLSSTOOLS_H
#define AGLSSTOOLS_H
#include <gmp.h>
#include "agltools.h"


typedef struct {
  char       *tt;
  agl    *by;
  shortvec   bp;
  aglGroup ldg;
  uint64_t count;
} record;

void ssswap( void );
aglGroup ssgen( void );
int strip( agl A , int i );
int nbgenss( void );
uint64_t ssOrder( void );
void   ssinit( void );
void   showss( void );
void   ssGroup( aglGroup g );
void   SchreierSims( agl A , int i);
void  ssfree( void );
void   mpz_ssOrder( mpz_t res );
int   isingroup( agl B );
void  mpz_aglorder( mpz_t res );

agl* devGroup( aglGroup S, uint64_t * size  );

#endif
