#include "stack.h"
#include "formtools.h"
#include "spacetools.h"
#include "orbitools.h"
#include <assert.h>

form*  formStack;
space* spaceStack;
vector* vectorStack;


size_t   ptrStack;
size_t   sizeStack;

int   realStack;

#define STACKLIMIT ( (1<<25) )


// stack orvector
//
void pushVector( vector w ){
	if ( ptrStack == sizeStack ) {
		realStack++;
		printf("\nreallocation %d...\n", realStack);
		sizeStack += STACKLIMIT;
		vectorStack = realloc( vectorStack ,  sizeStack *sizeof(vector) );
		if ( ! vectorStack ) {
			perror("stack");
			exit(1);
		}
	}
	vectorStack[ ptrStack++ ] = w;
}

vector popVector( ){
	if ( ptrStack == 0 ) {
		puts("stack underflow....");
		exit(1);
	}
	return vectorStack[ --ptrStack ] ;
}
void openVectorStack(){
	realStack = 0;
	sizeStack = STACKLIMIT;
	vectorStack = calloc( STACKLIMIT, sizeof(vector) );
}
void closeVectorStack(){
	free( vectorStack );
	realStack = 0;
	sizeStack = 0;
}

// space obsoltete...
//
void pushSpace( space w ){
	if ( ptrStack == sizeStack ) {
		realStack++;
		printf("\nreallocation %d...\n", realStack);
		sizeStack += STACKLIMIT;
		spaceStack = realloc( spaceStack ,  sizeStack *sizeof(space) );
		if ( ! spaceStack ) {
			perror("stack");
			exit(1);
		}
	}
	spaceStack[ ptrStack++ ] = w;
}

space popSpace( ){
	if ( ptrStack == 0 ) {
		puts("stack underflow....");
		exit(1);
	}
	return spaceStack[ --ptrStack ] ;
}
void openSpaceStack(){
	realStack = 0;
	sizeStack = STACKLIMIT;
	spaceStack = calloc( STACKLIMIT, sizeof(space) );
}
void closeSpaceStack(){
	free( spaceStack );
	realStack = 0;
	sizeStack = 0;
}


void pushForm( form w ){
	if ( ptrStack == sizeStack ) {
		realStack++;
		printf("\nreallocation %d...\n", realStack);
		sizeStack += STACKLIMIT;
		formStack = realloc( formStack ,  sizeStack *sizeof(form) );
		if ( ! formStack ) {
			perror("stack");
			exit(1);
		}
	}
	formStack[ ptrStack++ ] = w;
}

form popForm( ){
	if ( ptrStack == 0 ) {
		puts("stack underflow....");
		exit(1);
	}
	return formStack[ --ptrStack ] ;
}
void openFormStack(){
	realStack = 0;
	sizeStack = STACKLIMIT;
	formStack = calloc( STACKLIMIT, sizeof(form) );
}
void closeFormStack(){
	free( formStack );
	realStack = 0;
	sizeStack = 0;
}

void pushObject( object x, stack * p){
stack  aux;

aux = malloc(sizeof(enrstack));
aux -> info = x;
aux -> next = *p;
*p = aux;
return;
}

object  popObject( stack  * p){
stack  aux;
object res;

aux = *p;
assert( aux != NULL );
res  = aux -> info;
*p = aux -> next;
free(aux);
return res;
}

void push(form w, pile *p){
pile aux;

aux = malloc(sizeof(enrpile));
aux -> w = w;
aux -> next = *p;
*p = aux;
return;
}

form pop(pile * p){

form w;
pile aux;

aux = *p;
w = aux -> w;
*p = aux -> next;
free(aux);
return w;
}
