
#include "classtools.h"

void pushClass( boole fct,  aglGroup grp, ullong size, class *K )
{ class aux = calloc( 1, sizeof(enrclass) );
  aux->fct  = fct;
  aux->stab = grp;
  aux->size = size;
  aux->next = *K;
  *K = aux;
}
void popClass( class *K )
{ class aux;
  aux = *K;
  *K  = aux->next;
  aglfreeGroup( aux->stab );
  free( aux->fct );
  free(aux);
}

int classNumber( class  K )
{
int res =0;
while (K){
 	K=K->next;
 	res++;}
 	return res;
}

void pclass( FILE *dst, class aux )
{
			//pTT(stdout,aux->fct);
                        panf( dst, aux->fct );
                        paglGroup( dst, aux->stab );
                        fprintf( dst,"\nstabSize=%ld\n", aux->size );
}

void freeClass( class K )
{
class aux;
while ( K ){
	aux = K;
 	K  = K->next;
	free( aux->fct );
	aglfreeGroup( aux->stab );
	free( aux );}
}

class loadClass(FILE *src )
//-get the current boolean function
{ class res = NULL;
  boole f;
  aglGroup ldg = NULL;
  uint64_t size =0;
  char line[1024];
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
        {
        case '#':
          break;
        case 'a' :
          f =  strtoboole ( line );
          break;
        case '[' :
          addgen( strtoagl ( line ), &ldg );
          break;
        case 's' :
          sscanf( line, "stabSize=%ld", &size );
	  res = malloc( sizeof(enrclass) );
	  res->fct  = f;
	  res->size = size;
	  res->stab = ldg;
	  //pclass( res );
          return res;
          break;
        default:;
        }
    }
    return NULL;
}

void pall( class K )
{
int res = 0;
while (K){
	pTT(stdout,K->fct);
        panf( stdout, K->fct );
        paglGroup( stdout, K->stab );
        fprintf( stdout,"\norder:%ld\n", K->size );
 	K  = K->next;
 	res++;
}
printf("\n%d class\n", res );
}

FILE * openClass( char * dir, char * name, int r, int k, int m , char *mode)
{ char fn[128];
  FILE * res;
  sprintf( fn, "%s/%s-%d-%d-%d.dat", dir, name, r, k, m );
  res = fopen( fn, mode );
  if ( ! res ) {
	  perror("openClass");
	  puts(fn);
	  exit(1);
  }
  return res;
}



int  lastlevel( char * dir, char * name, int k, int m )
{ char fn[128];
  FILE * res;
  int r = 0;
  while ( r <= m +1 ) {
  	sprintf( fn, "%s/%s-%d-%d-%d.dat", dir, name, r, k, m );
 	res = fopen( fn, "r" );
  	if ( res ) {
	  fclose( res  );
	  return r;
	}
	r++;
  }
  fprintf(stderr, "\nno level...!\n");
  exit(1);
}

void addClass(class aux, class *K){
aux->next = *K;
*K = aux;
}
