#ifndef DISTRIB_CCZ_H
#define DISTRIB_CCZ_H
#include "boolean.h"
#include "classtools.h"
#include "spacetools.h"
#include "agltools.h"
#include "basistools.h"
#include "orbitools.h"
#include "invariantools.h"
#include "orbit.h"
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "time.h"
#include "code.h"
#include <search.h>

typedef struct _invdist_ {
        int  val;
        int  *dis ;
} dis_t;


extern int nouvelle;
int * compress( int* tfr, int q, int mode);
dis_t * getDistribution( int *t, int q, int mode );
int findtable( int *t, int q,  void **rootp, int* count, int mode);
int findspltable( int *t, int q,  void **rootp, int* count);
void glue( int *tfr, int* t, int q  );
#endif
