#ifndef MAPPING_H
#define MAPPING_H

#include "boolean.h"
#include <assert.h>

typedef uchar * mapping;
//-mapping type:table of value

mapping getmap(  void );

mapping strtomap(  char *bfr );
//-string to map : table of values.

int  isapn( mapping fct );
//-apn test

void xprintmap( FILE *dst, char *msg, mapping f);
//-print the anf components of the mapping f

int mapdegree( mapping f );
//-return the degree of the mapping f

boole component( galois v, mapping f );
//-return the v-component of f

void coordinate( mapping b, mapping f, int i);

mapping loadmap(FILE *src );
//-map loader

mapping  loadaglmapsize(FILE *src, aglGroup *g, uint64_t *size);


void printmap( char* msg, mapping f );
//-print the map f
void fprintmap( FILE*dst, mapping f );
//-print mapping in file

void fprintmapvalue( FILE*dst, int j, mapping f );

int maplevel( mapping g );
//-return the level of g

mapping  filemapsparameters( char *fn , int *cpt, int* level );
// first map, cardinality, and level in map file...
mapping  loadmapvalue(FILE *src, int *value );
mapping  loadparmsmap(FILE *src , int* val, int *rep );
// load map and parameter rep


#endif
