#ifndef STACK_H
#define STACK_H

#include "formtools.h"
#include "spacetools.h"
#include "basistools.h"
#include <stdint.h>

extern size_t sizeStack;
extern size_t ptrStack;

typedef struct {
	form w;
	agl s;
} object;

typedef struct _objectstack_ {
   object info;
   struct _objectstack_ * next;
} enrstack, *stack;


void pushObject( object , stack *);

object  popObject( stack *);

typedef struct _pile_ {
form w;
struct _pile_ * next;
}enrpile, *pile;


void push( form, pile *);
form pop(pile *);

void pushForm( form);
form popForm( );
void openFormStack();
void closeFormStack();

void pushVector( vector  );
vector  popVector( );
void openVectorStack();
void closeVectorStack();


void pushSpace( space );
space popSpace( );
void openSpaceStack();
void closeSpaceStack();
#endif
