#ifndef WORD_H
#define WORD_H
#include "boolean.h"
#include "classtools.h"
#include "spacetools.h"
#include "agltools.h"
#include "basistools.h"
#include "orbitools.h"
#include "invariantools.h"
#include "orbit.h"
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "time.h"
#include "code.h"

#include <stdint.h>

extern int wdlen;
#define _GNU_SOURCE
#include <search.h>
  void tdestroy(void *root, void (*free_node)(void *nodep));


typedef uint64_t  word;

typedef struct _word_ {
        int  val;
        word *dis ;
} wdis_t;

void initwd( int l );
void wsort( word * w);
void wfree( void * rootp );
wdis_t * getwdistribution( word  *t );
int searchwtable( word *t, void **rootp, int* count );


int findwtable( word *t, void **rootp, int* count );
#endif
